#include <allegro.h>

int instructions;
int output;
unsigned char hdmaon;
int padready=0;
unsigned char pbr;
unsigned short pc;

unsigned long vramaddr;

int inint;
unsigned char multa,multb,divb;
unsigned short multc,diva,divc;

int vertcomp;
int vblank=1;
int nmienable=0;
int intenable=0;
unsigned char dmactrl[8],dmadest[8],dmabank[8];
unsigned long dmasrc[8],dmasize[8];

unsigned char readio(unsigned short addr)
{
        unsigned char temp;
//        printf("read %04X %02X:%04X\n",addr,pbr,pc);
        if (addr==0x4016 || addr==0x4017)
        {
//                printf("Reading old style\n");
                return 0xFF;
        }
        switch (addr&0x1FF)
        {
                case 0x0B:
                return 0;

                case 0x10:
                if (vblank)
                {
                        vblank=0;
                        return 0x80;
                }
                return 0;
                case 0x11:
                if (inint)
                {
                        inint=0;
                        return 0x80;
                }
                return 0;
                case 0x12:
                temp=padready;
                padready^=0x41;
                if (vblank)
                   temp|=0x80;
                return temp;

                case 0x14:
                return diva&0xFF;
                case 0x15:
                return diva>>8;
                case 0x16:
                return multc&0xFF;
                case 0x17:
                return multc>>8;

                case 0x18:
                temp=0;
                if (key[KEY_S]) temp|=0x80;
                if (key[KEY_A]) temp|=0x40;
                if (key[KEY_Q]) temp|=0x20;
                if (key[KEY_W]) temp|=0x10;
                return temp;
                case 0x19:
                temp=0;
                if (key[KEY_X]) temp|=0x80;
                if (key[KEY_Z]) temp|=0x40;
                if (key[KEY_D]) temp|=0x20;
                if (key[KEY_C]) temp|=0x10;
                if (key[KEY_UP]) temp|=0x8;
                if (key[KEY_DOWN]) temp|=0x4;
                if (key[KEY_LEFT]) temp|=0x2;
                if (key[KEY_RIGHT]) temp|=0x1;
//                printf("Reading new style\n");
//                if (temp&0x10) output=1;
                return temp;

                case 0x1A:
                case 0x1B:
                case 0x1C:
                case 0x1D:
                case 0x1E:
                case 0x1F:
                return 0;

                case 0x100: case 0x110: case 0x120: case 0x130:
                case 0x140: case 0x150: case 0x160: case 0x170:
                return dmactrl[(addr>>4)&7];

                case 0x101: case 0x111: case 0x121: case 0x131:
                case 0x141: case 0x151: case 0x161: case 0x171:
                return dmadest[(addr>>4)&7];

                case 0x102: case 0x112: case 0x122: case 0x132:
                case 0x142: case 0x152: case 0x162: case 0x172:
                return dmasrc[(addr>>4)&7];

                case 0x103: case 0x113: case 0x123: case 0x133:
                case 0x143: case 0x153: case 0x163: case 0x173:
                return dmasrc[(addr>>4)&7]>>8;

                case 0x104: case 0x114: case 0x124: case 0x134:
                case 0x144: case 0x154: case 0x164: case 0x174:
                return dmasize[(addr>>4)&7]>>16;

                case 0x105: case 0x115: case 0x125: case 0x135:
                case 0x145: case 0x155: case 0x165: case 0x175:
                return dmasize[(addr>>4)&7];

                case 0x106: case 0x116: case 0x126: case 0x136:
                case 0x146: case 0x156: case 0x166: case 0x176:
                return dmasize[(addr>>4)&7]>>8;

                default:
//                printf("Reading %04X %02X:%04X\n",addr,pbr,pc);
        }
        return 0;
}

int dmaout=0;
void writeio(unsigned short addr, unsigned char val)
{
        int c,bank;
        int outdma=0;
        unsigned char d;
        unsigned long s;
        char st[80];
        switch (addr&0x1FF)
        {
                case 0:
                nmienable=val&0x80;
                intenable=val&0x30;
                break;

                case 0x02:
                multa=val;
                break;
                case 0x03:
                multb=val;
                multc=multa*multb;
                break;

                case 0x04:
                divc&=0xFF00;
                divc|=val;
                break;
                case 0x05:
                divc&=0xFF;
                divc|=val<<8;
                break;
                case 0x06:
                divb=val;
                if (!divc || !divb)
                {
                        diva=0xFFFF;
                        multc=divc;
                }
                else
                {
                        diva=divc/divb;
                        multc=divc%divb;
                }
                break;

                case 0x09:
                vertcomp=(vertcomp&0xFF00)|val;
                break;
                case 0xA:
                vertcomp=(vertcomp&0xFF)|(val<<8);
                break;

                case 0xB:
//                if (pc==0x8889 && val==4) { printf("%06X %02X %04X %02X %04X %i\n",dmasrc[2],dmadest[2],dmasize[2],dmactrl[2],vramaddr<<1,instructions); outdma=1; }
/*                if (pc==0xB5CB) printf("%05X %02X:%04X %02X\n",dmasize[0],dmasrc[0]>>16,dmasrc[0]&0xFFFF,dmadest[0]);
                if (pc==0xB5CB)
                {
                        dumpram();
                        exit(0);
                }*/
                for (c=0;c<8;c++)
                {
                        if (val&(1<<c))
                        {
//                                if (dmadest[c]==0x04/*output*/) printf("Channel %i src %06X dest %02X size %04X ctrl %02X VRAM addr %04X\n",c,dmasrc[c],dmadest[c],dmasize[c],dmactrl[c],vramaddr<<1);
                                d=dmadest[c];
                                s=dmasrc[c];
                                if (!dmasize[c]) dmasize[c]=0x10000;
                                while (dmasize[c])
                                {
//                                        if (outdma) printf("Read %06X Write 21%02X\n",s,d);
                                        if (dmactrl[c]&0x80)
                                           writemem(s>>16,s,readmem(0,0x2100|d));
                                        else
                                           writemem(0,0x2100|d,readmem(s>>16,s));
                                        switch (dmactrl[c]&0xF)
                                        {
                                                case 0:
                                                case 2:
                                                if (dmactrl[c]&16) s--;
                                                else               s++;
                                                break;

                                                case 1:
                                                if (d==dmadest[c]) d++;
                                                else               d--;
                                                if (dmactrl[c]&16) s--;
                                                else               s++;
                                                break;

                                                case 9:
                                                if (d==dmadest[c]) d++;
                                                else               d--;
                                                break;

                                                case 8:
                                                case 0xA:
                                                break;

                                                default:
                                                printf("DMA mode %i\n",dmactrl[c]&7);
                                                exit(-1);
                                        }
                                        dmasize[c]--;
                                }
//                                if (outdma) exit(0);
                                dmaout=0;
                                dmadest[c]=d;
                                dmasrc[c]=s;
                        }
                }
                break;

                case 0xC:
                hdmaon=val;
                break;

                case 0x10:
                vblank=0;
                break;
                case 0x11:
                inint=0;
                break;

                case 0x100: case 0x110: case 0x120: case 0x130:
                case 0x140: case 0x150: case 0x160: case 0x170:
                dmactrl[(addr>>4)&7]=val;
                break;

                case 0x101: case 0x111: case 0x121: case 0x131:
                case 0x141: case 0x151: case 0x161: case 0x171:
                dmadest[(addr>>4)&7]=val;
                break;

                case 0x102: case 0x112: case 0x122: case 0x132:
                case 0x142: case 0x152: case 0x162: case 0x172:
                dmasrc[(addr>>4)&7]&=0xFFFF00;
                dmasrc[(addr>>4)&7]|=val;
//                if ((addr&0x1FF)==0x162) printf("DMA low write %02X %02X:%04X\n",val,pbr,pc);
                break;

                case 0x103: case 0x113: case 0x123: case 0x133:
                case 0x143: case 0x153: case 0x163: case 0x173:
                dmasrc[(addr>>4)&7]&=0xFF00FF;
                dmasrc[(addr>>4)&7]|=val<<8;
                break;

                case 0x104: case 0x114: case 0x124: case 0x134:
                case 0x144: case 0x154: case 0x164: case 0x174:
                dmasrc[(addr>>4)&7]&=0x00FFFF;
                dmasrc[(addr>>4)&7]|=val<<16;
                break;

                case 0x105: case 0x115: case 0x125: case 0x135:
                case 0x145: case 0x155: case 0x165: case 0x175:
                dmasize[(addr>>4)&7]&=0xFF00;
                dmasize[(addr>>4)&7]|=val;
                break;

                case 0x106: case 0x116: case 0x126: case 0x136:
                case 0x146: case 0x156: case 0x166: case 0x176:
                dmasize[(addr>>4)&7]&=0xFF;
                dmasize[(addr>>4)&7]|=val<<8;
                break;

                case 0x107: case 0x117: case 0x127: case 0x137:
                case 0x147: case 0x157: case 0x167: case 0x177:
                dmabank[(addr>>4)&7]=val;
                break;
        }
}
